<?php

namespace Drupal\gifplayer\Plugin\Field\FieldWidget;

use Drupal\file\Plugin\Field\FieldWidget\FileWidget;
use Drupal\Core\Form\FormStateInterface;

/**
 * Plugin implementation of the 'gifplayer' widget.
 *
 * @FieldWidget(
 *   id = "gif_player_widget",
 *   module = "gifplayer",
 *   label = @Translation("Gif Player"),
 *   field_types = {
 *     "gifplayer"
 *   }
 * )
 */
class GifPlayerWidget extends FileWidget {

  /**
   * {@inheritdoc}
   */
  public static function defaultSettings() {
    return [
      'webm/mp4' => FALSE,
      'progress_indicator' => 'throbber',
    ] + parent::defaultSettings();
  }

  /**
   * {@inheritdoc}
   */
  public function settingsSummary() {
    $summary = [];

    $summary['progress_indicator'] = $this->t(
      'Progress indicator: @progress_indicator',
      ['@progress_indicator' => $this->getSetting('progress_indicator')]
    );

    return $summary;
  }

  /**
   * {@inheritdoc}
   */
  public function settingsForm(array $form, FormStateInterface $form_state) {
    $element = parent::settingsForm($form, $form_state);

    return $element;
  }
}
